;
; Less Wrong Prisoner's Dilemma Tournament
; Entry by Devin Bayer <lunchtime@doubly.so>
; 2013-6-15 version 3
;

(lambda (other)
   
  ; constant bots
  (define CooperateBot '(lambda (x) 'C))
  (define DefectBot '(lambda (x) 'D))
  (define ErrorBot '(lambda (x) '?))
  
  ; only cooperate if x cooperates
  (define MirrorBot '(lambda (x)
    ; re-define external variables
    (define ErrorBot '(lambda (x) '?))
                       
    (cond
      [(eq? ((eval x) ErrorBot) 'C) 'C]
      [else 'D])))
  
  ; only cooperate if it will make x cooperate
  (define MyBot '(lambda (x)
    ; re-define external variables
    (define CooperateBot '(lambda (x) 'C))
    (define DefectBot '(lambda (x) 'D))
    (define ErrorBot '(lambda (x) '?))
    (define MirrorBot '(lambda (x)
      ; re-define external variables
      (define ErrorBot '(lambda (x) '?))
     
      (cond
        [(eq? ((eval x) ErrorBot) 'C) 'C]
        [else 'D])))
                   
    (cond
      [(eq? ((eval x) DefectBot) 'C) 'D]
      [(eq? ((eval x) CooperateBot) 'C) 'C]
      [(eq? ((eval x) MirrorBot) 'C) 'C]
      [else 'D])))
  
  ; do a unit test
  (define (test x y)
    (if (eq? x y)
        [void printf "ok ~a = ~a\n" x y]
        [printf "ERROR ~a != ~a\n" x y]))
  
  ; run tests
  (test ((eval MyBot) CooperateBot) 'D)
  (test ((eval MyBot) DefectBot) 'D)
  (test ((eval MyBot) MirrorBot) 'C)
  (test ((eval MyBot) ErrorBot) 'D)
  (test ((eval MyBot) MyBot) 'C)
  
  ; return my bot
  ((eval MyBot) other)
  )